<?php
// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('GET_EDIT_TEMPLATES', true);
define('THIS_SCRIPT', 'ajaxchangstat');
define('CSRF_PROTECTION', true);
define('LOCATION_BYPASS', 1);
define('NOPMPOPUP', 1);

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array();

// get special data templates from the datastore
$specialtemplates = array();

// pre-cache templates used by all actions
$globaltemplates = array(
	'changuondyu_stats_script',
	'changuondyu_advancedstats_main',
	'changuondyu_chooselatestposts',
	'changuondyu_latestpost_head',
	'changuondyu_latestpost_bit',
	'changuondyu_top_head',
	'changuondyu_top_bit',
	'changuondyu_chooseoption'
);

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');

if ($vbulletin->options['changstats_turn'])
{
	$bgclass = "alt2";
	// get result value
	$vbulletin->input->clean_array_gpc('r', array(
 		'listforumid' => TYPE_NOHTML,		
		'result' => TYPE_UINT
	));
	$cresult = intval($vbulletin->GPC['result']);

	if ($checkonerow)
	{
		$cresult_alt = $cresult;
		$ch1 = ($cresult + 1) * 16;
		$ch2 = $ch1;
	} else
	{
		$cresult_alt = floor($cresult / 2);
		$ch2 = $cresult_alt * 16;
		$ch1 = $ch2 * 2 + 38;
	}

	$listr2 = explode(",", $vbulletin->options['changstats_chooseresult']);
	if (in_array($cresult, $listr2))
	{

		if ($_REQUEST['do'] == 'allforum' OR $_REQUEST['do'] == 'inforum')
		{
			$changstatsforumperms = array();
			foreach ($vbulletin->forumcache AS $changtsforum)
			{
				$changstatsforumperms[$changtsforum["forumid"]] = fetch_permissions($changtsforum['forumid']);
				if ((!($changstatsforumperms[$changtsforum["forumid"]] & $vbulletin->bf_ugp_forumpermissions['canview'])) OR
					(!($changtsforum['options'] & $vbulletin->bf_misc_forumoptions['active']) AND !$vbulletin->options['showprivateforums'] AND
					!in_array($vbulletin->userinfo['usergroupid'], array(5, 6, 7))))
				{
					$limitfids .= ',' . $changtsforum['forumid'];
				}
			}
			unset($changtsforum);
			$hiddenforum = $limitfids;

			if ($vbulletin->options[changstats_hiddenforum])
			{
				$hiddenforum .= ',' . $vbulletin->options[changstats_hiddenforum];
			}

			$threadclimit = $vbulletin->options['changstats_trim_threadtitle']; // thread title trim
			$forumclimit = $vbulletin->options['changstats_trim_forumtitle']; // forum title trim
			$userclimit = $vbulletin->options['changstats_trim_username']; // username trim
			
			$vlastvisit = $vbulletin->userinfo['lastvisit']; // get lastvisit of logged user
			
			$foruminid = $vbulletin->db->escape_string($vbulletin->GPC['listforumid']);
			
			$latestpostq = $vbulletin->db->query_read("
				SELECT thread.threadid, thread.title, " . iif($vbulletin->options['top_lpshowprefix'], ' thread.prefixid,') . " thread.lastpost, thread.lastpostid, thread.forumid, thread.replycount, thread.views, thread.lastposter, thread.postusername AS threadstarter, thread.dateline, thread.visible, thread.open, user.username, user.userid, user.usergroupid, IF(user.displaygroupid=0, user.usergroupid, user.displaygroupid) AS displaygroupid
				FROM " . TABLE_PREFIX . "thread AS thread
				LEFT JOIN " . TABLE_PREFIX . "user AS user ON (user.username = thread.lastposter)
				WHERE NOT ISNULL(thread.threadid)
				AND thread.visible = '1'
				AND thread.open != '10'
				" . iif($_REQUEST['do'] != 'allforum', 'AND thread.forumid IN (' . $foruminid . ')') . "
				AND thread.forumid NOT IN (0$hiddenforum)
				AND thread.lastpostid > 0
				ORDER BY lastpost DESC
				LIMIT $cresult
			");

			while ($latestpost = $vbulletin->db->fetch_array($latestpostq))
			{
				$bgclass = exec_switch_bg();
				$latestpost[fulltitle] = $latestpost[title];
				$latestpost[fullposter] = $latestpost[lastposter];
				if ($vbulletin->options['changstats_lpshowprefix'] && $latestpost[prefixid])
				{
					$latestpost[prefixplain] = $vbphrase['prefix_' . $latestpost[prefixid] . '_title_plain'];
					$latestpost[prefixrich] = $vbphrase['prefix_' . $latestpost[prefixid] . '_title_rich'];
				}

				$clastpost = $latestpost[lastpost];
				// change time format
				$latestpost[lastposttime_alt] = vbdate($vbulletin->options['dateformat'], $latestpost[lastpost], 1) . ' ' . vbdate($vbulletin->options['timeformat'], $latestpost[lastpost]);
				$latestpost[lastpost] = vbdate($vbulletin->options['changstats_formatlatestpost'], $latestpost[lastpost]);
				$latestpost[threadstarttime] = vbdate($vbulletin->options['dateformat'], $latestpost[dateline], 1) . ' ' . vbdate($vbulletin->options['timeformat'], $latestpost[dateline]);

				// trim thread title
				$latestpost[full_title] = $latestpost[title];
				if ($threadclimit > 0)
				{
					$latestpost[title] = fetch_trimmed_title($latestpost[title], $threadclimit - strlen($latestpost[prefixplain]));
				}

				// get forum title store thread and trim
				$forumname = strip_tags($vbulletin->forumcache["$latestpost[forumid]"]['title_clean']); // remove html tag
				$forumnamefull = $forumname; // get full orum title
				if ($forumclimit > 0)
				{
					$forumname = fetch_trimmed_title($forumname, $forumclimit);
				}

				// get lastposter id and markup and trim
				$latestpost[fulllastposter] = $latestpost[lastposter];
				$latestpost[lastposter_tg] = str_replace("'", "\'", $latestpost[lastposter]);

				// get threadstarter and markup
//				$latestpost[threadstarter] = $vbulletin->usergroupcache["$latestpost[displaygroupid]"]['opentag'] . $latestpost[threadstarter] . $vbulletin->usergroupcache["$latestpost[displaygroupid]"]['closetag'];

				$latestpost[lastposterid] = $latestpost[userid];
				$latestpost[lastposter] = fetch_musername($latestpost);
				$latestpost[lastposter_alt] = $latestpost[lastposter];
				$latestpost[full_lastposter] = $latestpost[username];
				if ($userclimit > 0 AND strlen($latestpost[full_lastposter]) > $userclimit)
				{
					$latestpost[lastposter] = $vbulletin->usergroupcache["$latestpost[displaygroupid]"]['opentag'] . fetch_trimmed_title($latestpost[full_lastposter], $userclimit) . $vbulletin->usergroupcache["$latestpost[displaygroupid]"]['closetag'];
				}

				$pstatus = ($vlastvisit > $clastpost) ? 'old' : 'new'; // check read

				eval('$changtop_lastpost_bit .= "' . $vbulletin->templatecache['changuondyu_latestpost_bit'] . '";');
			}

			eval('print_output("' . fetch_template('changuondyu_latestpost_head') . '");');
		}


		// TOP
		$toplist = $vbulletin->options['changstats_topselect_1'] . ',' . $vbulletin->options['changstats_topselect_2'] . ',' . $vbulletin->options['changstats_topselect_3'] . ',' . $vbulletin->options['changstats_topselect_4'];
		$toplist = explode(',', $toplist);

		if ($vbulletin->options['changstats_top_turn'] && in_array($_REQUEST['do'], $toplist))
		{

			// Trim Value
			$topuserclimit = $vbulletin->options['changstats_topusertrim'];
			$topthreadclimit = $vbulletin->options['changstats_topthreadtrim'];
			$topforumclimit = $vbulletin->options['changstats_topforumtrim'];


			/////////////// Newest Member /////////////////
			if ($_REQUEST['do'] == 'newmember')
			{
				$top_query = $vbulletin->db->query_read("
					SELECT userid,username,joindate,usergroupid,displaygroupid 
					FROM " . TABLE_PREFIX . "user 
					ORDER BY userid DESC 
					LIMIT $cresult_alt
				");
				while ($top = $vbulletin->db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$title = $top[username];
					if ($topuserclimit > 0)
					{
						$top[username] = fetch_trimmed_title($top[username], $topuserclimit);
					}
					$top[username] = fetch_musername($top);

					$colum1 = "<a href='member.php?u=" . $top[userid] . "'>" . $top[username] . "</a>";
					$colum2 = vbdate($vbulletin->options['changstats_userdate'], $top[joindate]);

					$head1 = $vbphrase[username];
					$head2 = $vbphrase[join_date];

					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}


			/////////////// Top Poster //////////////////
			if ($_REQUEST['do'] == 'topposter')
			{
				$top_query = $vbulletin->db->query_read("
					SELECT userid,username,posts,usergroupid,displaygroupid 
					FROM " . TABLE_PREFIX . "user 
					ORDER BY posts DESC 
					LIMIT $cresult_alt
				");
				while ($top = $vbulletin->db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$title = $top[username];
					if ($topuserclimit > 0)
					{
						$top[username] = fetch_trimmed_title($top[username], $topuserclimit);
					}
					$top[username] = fetch_musername($top);
					$colum1 = "<a href='member.php?u=" . $top[userid] . "'>" . $top[username] . "</a>";
					$colum2 = $top[posts];

					$head1 = $vbphrase[username];
					$head2 = $vbphrase[posts];

					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}


			/////////////// Richest member //////////////////
			if ($_REQUEST['do'] == 'toprich')
			{
				$point_field = $vbulletin->options['changstats_pointfield'];
				$top_query = $vbulletin->db->query_read("
					SELECT userid,username,$point_field,usergroupid,displaygroupid 
					FROM " . TABLE_PREFIX . "user 
					ORDER BY $point_field DESC 
					LIMIT $cresult_alt
				");
				while ($top = $vbulletin->db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$title = $top[username];
					if ($topuserclimit > 0)
					{
						$top[username] = fetch_trimmed_title($top[username], $topuserclimit);
					}
					$top[username] = fetch_musername($top);
					$colum1 = "<a href='member.php?u=" . $top[userid] . "'>" . $top[username] . "</a>";
					$colum2 = round($top[$point_field]);

					$head1 = $vbphrase[username];
					$head2 = $vbphrase[changamount];

					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}


			/////////////// Top Thank //////////////////
			if ($_REQUEST['do'] == 'topthank')
			{
				$top_query = $vbulletin->db->query_read("
					SELECT userid,username,post_thanks_thanked_times,usergroupid,displaygroupid 
					FROM " . TABLE_PREFIX . "user 
					ORDER BY post_thanks_thanked_times DESC 
					LIMIT $cresult_alt
				");
				while ($top = $vbulletin->db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$title = $top[username];
					if ($topuserclimit > 0)
					{
						$top[username] = fetch_trimmed_title($top[username], $topuserclimit);
					}
					$top[username] = fetch_musername($top);
					$colum1 = "<a href='member.php?u=" . $top[userid] . "'>" . $top[username] . "</a>";
					$colum2 = $top[post_thanks_thanked_times];

					$head1 = $vbphrase[username];
					$head2 = $vbphrase[changamount];

					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}


			///////////// Most Reply Threads ///////////////////
			if ($_REQUEST['do'] == 'mostreplythread')
			{
				$top_query = $vbulletin->db->query_read("
					SELECT threadid,title,replycount 
					FROM " . TABLE_PREFIX . "thread 
					ORDER BY replycount DESC 
					LIMIT $cresult_alt
				");
				while ($top = $vbulletin->db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$title = $top[title];
					if ($topthreadclimit > 0)
					{
						$top[title] = fetch_trimmed_title($top[title], $topthreadclimit);
					}
					$colum1 = "<a href='showthread.php?t=" . $top[threadid] . "'>" . $top[title] . "</a>";
					$colum2 = $top[replycount];

					$head1 = $vbphrase[thread];
					$head2 = $vbphrase[replies];

					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}


			///////////// Most view thread ///////////////////
			if ($_REQUEST['do'] == 'mostviewthread')
			{
				$top_query = $vbulletin->db->query_read("
					SELECT threadid,title,views 
					FROM " . TABLE_PREFIX . "thread 
					ORDER BY views DESC 
					LIMIT $cresult_alt
				");
				while ($top = $vbulletin->db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$title = $top[title];
					if ($topthreadclimit > 0)
					{
						$top[title] = fetch_trimmed_title($top[title], $topthreadclimit);
					}
					$colum1 = "<a href='showthread.php?t=" . $top[threadid] . "'>" . $top[title] . "</a>";
					$colum2 = $top[views];
					$head1 = $vbphrase[thread];
					$head2 = $vbphrase[views];
					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}


			//////////////////// Most popular forum ////////////////
			if ($_REQUEST['do'] == 'mostpopularforum')
			{
				$top_query = $vbulletin->db->query_read("
					SELECT forumid,title,replycount 
					FROM " . TABLE_PREFIX . "forum 
					ORDER BY replycount DESC 
					LIMIT $cresult_alt
				");
				while ($top = $vbulletin->db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$top[title] = strip_tags($top[title]);
					$title = $top[title];

					if ($topforumclimit > 0)
					{
						$top[title] = fetch_trimmed_title($top[title], $topforumclimit);
					}
					$colum1 = "<a href='forumdisplay.php?f=" . $top[forumid] . "'>" . $top[title] . "</a>";
					$colum2 = $top[replycount];
					$head1 = $vbphrase[forum];
					$head2 = '';
					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}

			//////////////////// Newest Polls ////////////////
			if ($_REQUEST['do'] == 'newpoll')
			{
				$top_query = $vbulletin->db->query_read("
					SELECT poll.pollid,poll.question,thread.pollid,thread.threadid,thread.title
					FROM " . TABLE_PREFIX . "poll AS poll
					LEFT JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.pollid = poll.pollid)
					WHERE poll.active = 1 
					ORDER BY poll.pollid DESC 
					LIMIT $cresult_alt
				");
				while ($top = $vbulletin->db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$title = $top[title];
					if ($topthreadclimit > 0)
					{
						$top[title] = fetch_trimmed_title($top[title], $topforumclimit);
					}

					$colum1 = "<a href='showthread.php?t=" . $top[threadid] . "'>" . $top[title] . "</a>";
					$colum2 = '';

					$head1 = $vbphrase[thread];
					$head2 = '';

					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}


			//////////////////// Most Voted Polls ////////////////
			if ($_REQUEST['do'] == 'mostvotepoll')
			{
				$top_query = $vbulletin->db->query_read("
					SELECT poll.pollid,poll.question,poll.voters,thread.pollid,thread.threadid,thread.title
					FROM " . TABLE_PREFIX . "poll AS poll
					LEFT JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.pollid = poll.pollid)
					WHERE poll.active = 1 
					ORDER BY poll.voters DESC 
					LIMIT $cresult_alt
				");
				while ($top = $vbulletin->db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$title = $top[title];
					if ($topthreadclimit > 0)
					{
						$top[title] = fetch_trimmed_title($top[title], $topforumclimit);
					}

					$colum1 = "<a href='showthread.php?t=" . $top[threadid] . "'>" . $top[title] . "</a>";
					$colum2 = $top[voters];

					$head1 = $vbphrase[thread];
					$head2 = $vbphrase[votes];

					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}


			/////////////// Latest Banned Users /////////////////
			if ($_REQUEST['do'] == 'banneduser')
			{
				$top_query = $vbulletin->db->query_read("
					SELECT userban.userid,userban.bandate,user.usergroupid, user.displaygroupid,user.username
					FROM " . TABLE_PREFIX . "userban AS userban
					LEFT JOIN " . TABLE_PREFIX . "user AS user ON (user.userid = userban.userid)
					ORDER BY userban.bandate DESC 
					LIMIT $cresult_alt
				");
				while ($top = $vbulletin->db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$title = $top[username];
					if ($topuserclimit > 0)
					{
						$top[username] = fetch_trimmed_title($top[username], $topuserclimit);
					}
					$top[username] = fetch_musername($top);
					$colum1 = "<a href='member.php?u=" . $top[userid] . "'>" . $top[username] . "</a>";
					$colum2 = vbdate($vbulletin->options['changstats_userdate'], $top[bandate]);

					$head1 = $vbphrase[username];
					$head2 = $vbphrase[date];

					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}


			/////////////// Top Thread Starters /////////////////
			if ($_REQUEST['do'] == 'threadstarter')
			{
				$top_query = $vbulletin->db->query_read("
					SELECT COUNT(thread.threadid) AS threads, thread.postuserid, thread.dateline, user.userid, user.usergroupid, user.displaygroupid, user.username
					FROM " . TABLE_PREFIX . "thread AS thread
					LEFT JOIN " . TABLE_PREFIX . "user AS user ON (thread.postuserid = user.userid)
					LEFT JOIN " . TABLE_PREFIX . "forum AS forum ON (forum.forumid = thread.forumid)
					WHERE thread.visible='1'
					GROUP BY thread.postuserid
					ORDER BY threads DESC
					LIMIT $cresult_alt
				");
				while ($top = $db->fetch_array($top_query))
				{
					$bgclass = exec_switch_bg();
					$title = $top[username];
					if ($topuserclimit > 0)
					{
						$top[username] = fetch_trimmed_title($top[username], $topuserclimit);
					}
					$top[username] = fetch_musername($top);

					$colum1 = "<a href='member.php?u=" . $top[userid] . "'>" . $top[username] . "</a>";
					$colum2 = $top[threads];

					$head1 = $vbphrase[username];
					$head2 = $vbphrase[threads];

					eval('$chang_top_element .= "' . fetch_template('changuondyu_top_bit') . '";');
				}
				eval('print_output("' . fetch_template('changuondyu_top_head') . '");');
			}

		}
	} // top turn
}
?>